/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


/*****************************************************************************
******************************************************************************
**                                                                            
**        Y     Y   OOOO    OOOO   DDDDD     AA
**         Y   Y   O    O  O    O  D    D   A  A
**          Y Y    O    O  O    O  D    D  A    A 
**           Y     O    O  O    O  D    D  AAAAAA
**           Y     O    O  O    O  D    D  A    A
**           Y      OOOO    OOOO   DDDDD   A    A
**
******************************************************************************
******************************************************************************/
/*****************************************************************************
*
*  MODULE :             exceptions management
*  SCOPE :              
*  FILE :               yooexcept.cc
*  AUTHORS :            E. Abecassis
*  CREATION DATE :      August 1, 1993
*  COPYRIGHTS :        (C) E. Abecassis, 1993
*  HISTORY :
*
******************************************************************************/

#ifdef __GNUG__
#pragma implementation
#endif

/* IMPORTS *******************************************************************/

#define __GLOBAL_TOOLS_DEFINITION__

#ifndef __yooexcept_HXX
#include "yooexcept.hxx"
#endif

#include <stdio.h>
#include <stdlib.h>


void (*yoo_hook_exit)() = NULL ;

/*****************************************************************************/

void yoo_exit(int err) {
  exit(err) ;
  if (yoo_hook_exit != NULL) yoo_hook_exit() ;
}

void yoo_sethook(void (*hook)()) {
  yoo_hook_exit = hook ;
}

void yoo_error(int errnum, char* s)
{
  printf("Error %d : %s\n", errnum, s) ;
}

void call_throw(int err, char* str) {

  yoo_error(err, str) ;
  THROW(err) ;
}

void call_throw(int err) {

  THROW(err) ;
}


extern "C" {
  void call_throw_c(int err) {

    THROW(err) ;
  }
}


